/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
import express from "express";
import operations from "../operations/index.js";
import { ValidationError } from "./types.js";
import { validateGetInstitutionsInput, validateGetInstitutionsOutput, validatePostInstitutionsInput, validatePostInstitutionsOutput, validateGetInstitutionsByInstitutionIdInput, validateGetInstitutionsByInstitutionIdOutput, validatePatchInstitutionsByInstitutionIdInput, validatePatchInstitutionsByInstitutionIdOutput, validateDeleteInstitutionsByInstitutionIdInput, validateDeleteInstitutionsByInstitutionIdOutput, validateGetProxyInput, validateGetProxyOutput, validatePostProxyInput, validatePostProxyOutput, validatePutProxyInput, validatePutProxyOutput, validatePatchProxyInput, validatePatchProxyOutput, validateDeleteProxyInput, validateDeleteProxyOutput, validateHeadProxyInput, validateHeadProxyOutput, validateOptionsProxyInput, validateOptionsProxyOutput, validateTraceProxyInput, validateTraceProxyOutput } from "./requestValidation.js";
export default function router() {
    const router = express.Router();
    router.get("/institutions", async (req, res, next) => {
        try {
            if (!validateGetInstitutionsInput()) {
                throw new ValidationError("Request validation failed", validateGetInstitutionsInput.errors, 400);
            }
            const result = await operations.getInstitutions(req);
            if (!validateGetInstitutionsOutput(result)) {
                throw new ValidationError("Response validation failed", validateGetInstitutionsOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/institutions", async (req, res, next) => {
        const body = req.body;
        try {
            if (!validatePostInstitutionsInput(body)) {
                throw new ValidationError("Request validation failed", validatePostInstitutionsInput.errors, 400);
            }
            const result = await operations.postInstitutions(req, body);
            if (!validatePostInstitutionsOutput(result)) {
                throw new ValidationError("Response validation failed", validatePostInstitutionsOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/institutions/:institution_id", async (req, res, next) => {
        const parameters = {
            "institution_id": req.params["institution_id"]
        };
        try {
            if (!validateGetInstitutionsByInstitutionIdInput(parameters)) {
                throw new ValidationError("Request validation failed", validateGetInstitutionsByInstitutionIdInput.errors, 400);
            }
            const result = await operations.getInstitutionsByInstitutionId(req, parameters);
            if (!validateGetInstitutionsByInstitutionIdOutput(result)) {
                throw new ValidationError("Response validation failed", validateGetInstitutionsByInstitutionIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/institutions/:institution_id", async (req, res, next) => {
        const parameters = {
            "institution_id": req.params["institution_id"]
        };
        const body = req.body;
        try {
            if (!validatePatchInstitutionsByInstitutionIdInput(parameters, body)) {
                throw new ValidationError("Request validation failed", validatePatchInstitutionsByInstitutionIdInput.errors, 400);
            }
            const result = await operations.patchInstitutionsByInstitutionId(req, parameters, body);
            if (!validatePatchInstitutionsByInstitutionIdOutput(result)) {
                throw new ValidationError("Response validation failed", validatePatchInstitutionsByInstitutionIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/institutions/:institution_id", async (req, res, next) => {
        const parameters = {
            "institution_id": req.params["institution_id"]
        };
        try {
            if (!validateDeleteInstitutionsByInstitutionIdInput(parameters)) {
                throw new ValidationError("Request validation failed", validateDeleteInstitutionsByInstitutionIdInput.errors, 400);
            }
            const result = await operations.deleteInstitutionsByInstitutionId(req, parameters);
            if (!validateDeleteInstitutionsByInstitutionIdOutput(result)) {
                throw new ValidationError("Response validation failed", validateDeleteInstitutionsByInstitutionIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validateGetProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validateGetProxyInput.errors, 400);
            }
            const result = await operations.getProxy(req, parameters, body);
            if (!validateGetProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validateGetProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validatePostProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validatePostProxyInput.errors, 400);
            }
            const result = await operations.postProxy(req, parameters, body);
            if (!validatePostProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validatePostProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.put("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validatePutProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validatePutProxyInput.errors, 400);
            }
            const result = await operations.putProxy(req, parameters, body);
            if (!validatePutProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validatePutProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validatePatchProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validatePatchProxyInput.errors, 400);
            }
            const result = await operations.patchProxy(req, parameters, body);
            if (!validatePatchProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validatePatchProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validateDeleteProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validateDeleteProxyInput.errors, 400);
            }
            const result = await operations.deleteProxy(req, parameters, body);
            if (!validateDeleteProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validateDeleteProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.head("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validateHeadProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validateHeadProxyInput.errors, 400);
            }
            const result = await operations.headProxy(req, parameters, body);
            if (!validateHeadProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validateHeadProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.options("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validateOptionsProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validateOptionsProxyInput.errors, 400);
            }
            const result = await operations.optionsProxy(req, parameters, body);
            if (!validateOptionsProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validateOptionsProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.trace("/proxy", async (req, res, next) => {
        const parameters = {
            "URL": req.query["URL"]
        };
        const body = req.body;
        try {
            if (!validateTraceProxyInput(parameters)) {
                throw new ValidationError("Request validation failed", validateTraceProxyInput.errors, 400);
            }
            const result = await operations.traceProxy(req, parameters, body);
            if (!validateTraceProxyOutput(result)) {
                throw new ValidationError("Response validation failed", validateTraceProxyOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
//# sourceMappingURL=routes.js.map